/* Simulator instruction decoder for ppc.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 2000, 2001 Red Hat, Inc.

This file is part of the Red Hat simulators.


*/


#include "ppcbf.h"

using namespace ppcbf; // FIXME: namespace organization still wip


// The instruction descriptor array. 

ppc_idesc ppc_idesc::idesc_table[PPC_INSN_MFTB + 1] =
{
  { ppc_sem_x_invalid, "X_INVALID", PPC_INSN_X_INVALID, { 0|(1<<CGEN_INSN_VIRTUAL), (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_add, "ADD", PPC_INSN_ADD, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_addc, "ADDC", PPC_INSN_ADDC, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_adde, "ADDE", PPC_INSN_ADDE, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_addme, "ADDME", PPC_INSN_ADDME, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_addze, "ADDZE", PPC_INSN_ADDZE, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_addic, "ADDIC", PPC_INSN_ADDIC, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_addic_, "ADDIC_", PPC_INSN_ADDIC_, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_addi, "ADDI", PPC_INSN_ADDI, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_addis, "ADDIS", PPC_INSN_ADDIS, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_neg, "NEG", PPC_INSN_NEG, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_subf, "SUBF", PPC_INSN_SUBF, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_subfc, "SUBFC", PPC_INSN_SUBFC, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_subfe, "SUBFE", PPC_INSN_SUBFE, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_subfme, "SUBFME", PPC_INSN_SUBFME, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_subfze, "SUBFZE", PPC_INSN_SUBFZE, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_divw, "DIVW", PPC_INSN_DIVW, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_divwu, "DIVWU", PPC_INSN_DIVWU, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_subfic, "SUBFIC", PPC_INSN_SUBFIC, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_mulhw, "MULHW", PPC_INSN_MULHW, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_mulhwu, "MULHWU", PPC_INSN_MULHWU, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_mulli, "MULLI", PPC_INSN_MULLI, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_mullw, "MULLW", PPC_INSN_MULLW, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_cmpix, "CMPIX", PPC_INSN_CMPIX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_cmplix, "CMPLIX", PPC_INSN_CMPLIX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_cmp, "CMP", PPC_INSN_CMP, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_cmpl, "CMPL", PPC_INSN_CMPL, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_and, "AND", PPC_INSN_AND, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_andc, "ANDC", PPC_INSN_ANDC, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_andi_, "ANDI_", PPC_INSN_ANDI_, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_andis_, "ANDIS_", PPC_INSN_ANDIS_, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_or, "OR", PPC_INSN_OR, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_orc, "ORC", PPC_INSN_ORC, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_nor, "NOR", PPC_INSN_NOR, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_nand, "NAND", PPC_INSN_NAND, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_eqv, "EQV", PPC_INSN_EQV, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_xor, "XOR", PPC_INSN_XOR, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_xori, "XORI", PPC_INSN_XORI, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_xoris, "XORIS", PPC_INSN_XORIS, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_ori, "ORI", PPC_INSN_ORI, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_oris, "ORIS", PPC_INSN_ORIS, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_extsb, "EXTSB", PPC_INSN_EXTSB, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_extsh, "EXTSH", PPC_INSN_EXTSH, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_rlwimi, "RLWIMI", PPC_INSN_RLWIMI, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_rlwinm, "RLWINM", PPC_INSN_RLWINM, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_rlwnm, "RLWNM", PPC_INSN_RLWNM, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_slw, "SLW", PPC_INSN_SLW, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_sraw, "SRAW", PPC_INSN_SRAW, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_srawi, "SRAWI", PPC_INSN_SRAWI, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_srw, "SRW", PPC_INSN_SRW, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lbz, "LBZ", PPC_INSN_LBZ, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lbzu, "LBZU", PPC_INSN_LBZU, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lbzux, "LBZUX", PPC_INSN_LBZUX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lbzx, "LBZX", PPC_INSN_LBZX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lha, "LHA", PPC_INSN_LHA, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lhau, "LHAU", PPC_INSN_LHAU, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lhaux, "LHAUX", PPC_INSN_LHAUX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lhax, "LHAX", PPC_INSN_LHAX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lhz, "LHZ", PPC_INSN_LHZ, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lhzu, "LHZU", PPC_INSN_LHZU, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lhzux, "LHZUX", PPC_INSN_LHZUX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lhzx, "LHZX", PPC_INSN_LHZX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lwz, "LWZ", PPC_INSN_LWZ, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lwzu, "LWZU", PPC_INSN_LWZU, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lwzux, "LWZUX", PPC_INSN_LWZUX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lwzx, "LWZX", PPC_INSN_LWZX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lhbrx, "LHBRX", PPC_INSN_LHBRX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lwbrx, "LWBRX", PPC_INSN_LWBRX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lwarx, "LWARX", PPC_INSN_LWARX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_lmw, "LMW", PPC_INSN_LMW, { 0|(1<<CGEN_INSN_COND_CTI), (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_stb, "STB", PPC_INSN_STB, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_stbu, "STBU", PPC_INSN_STBU, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_stbux, "STBUX", PPC_INSN_STBUX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_stbx, "STBX", PPC_INSN_STBX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_sth, "STH", PPC_INSN_STH, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_sthu, "STHU", PPC_INSN_STHU, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_sthux, "STHUX", PPC_INSN_STHUX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_sthx, "STHX", PPC_INSN_STHX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_stw, "STW", PPC_INSN_STW, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_stwu, "STWU", PPC_INSN_STWU, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_stwux, "STWUX", PPC_INSN_STWUX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_stwx, "STWX", PPC_INSN_STWX, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_stmw, "STMW", PPC_INSN_STMW, { 0|(1<<CGEN_INSN_COND_CTI), (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_tw, "TW", PPC_INSN_TW, { 0|(1<<CGEN_INSN_COND_CTI), (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_twi, "TWI", PPC_INSN_TWI, { 0|(1<<CGEN_INSN_COND_CTI), (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_sc, "SC", PPC_INSN_SC, { 0|(1<<CGEN_INSN_UNCOND_CTI), (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_USER } },
  { ppc_sem_rfi, "RFI", PPC_INSN_RFI, { 0|(1<<CGEN_INSN_UNCOND_CTI), (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_SUPERVISOR } },
  { ppc_sem_b, "B", PPC_INSN_B, { 0|(1<<CGEN_INSN_UNCOND_CTI), (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_bcctr, "BCCTR", PPC_INSN_BCCTR, { 0|(1<<CGEN_INSN_COND_CTI), (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_bclr, "BCLR", PPC_INSN_BCLR, { 0|(1<<CGEN_INSN_COND_CTI), (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_bc, "BC", PPC_INSN_BC, { 0|(1<<CGEN_INSN_COND_CTI), (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_crand, "CRAND", PPC_INSN_CRAND, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_cror, "CROR", PPC_INSN_CROR, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_crxor, "CRXOR", PPC_INSN_CRXOR, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_crandc, "CRANDC", PPC_INSN_CRANDC, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_creqv, "CREQV", PPC_INSN_CREQV, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_crnand, "CRNAND", PPC_INSN_CRNAND, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_crnor, "CRNOR", PPC_INSN_CRNOR, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_crorc, "CRORC", PPC_INSN_CRORC, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_mcrf, "MCRF", PPC_INSN_MCRF, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_mcrxr, "MCRXR", PPC_INSN_MCRXR, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_mfcr, "MFCR", PPC_INSN_MFCR, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_dcba, "DCBA", PPC_INSN_DCBA, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_dcbf, "DCBF", PPC_INSN_DCBF, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_dcbi, "DCBI", PPC_INSN_DCBI, { 0, (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_SUPERVISOR } },
  { ppc_sem_dcbst, "DCBST", PPC_INSN_DCBST, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_dcbt, "DCBT", PPC_INSN_DCBT, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_dcbtst, "DCBTST", PPC_INSN_DCBTST, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_dcbz, "DCBZ", PPC_INSN_DCBZ, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_icbi, "ICBI", PPC_INSN_ICBI, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_isync, "ISYNC", PPC_INSN_ISYNC, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_sync, "SYNC", PPC_INSN_SYNC, { 0, (1<<MACH_BASE), ARCH_LEVEL_UISA, INSN_LEVEL_USER } },
  { ppc_sem_tlbia, "TLBIA", PPC_INSN_TLBIA, { 0, (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_SUPERVISOR } },
  { ppc_sem_tlbsync, "TLBSYNC", PPC_INSN_TLBSYNC, { 0, (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_SUPERVISOR } },
  { ppc_sem_tlbie, "TLBIE", PPC_INSN_TLBIE, { 0, (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_SUPERVISOR } },
  { ppc_sem_eciwx, "ECIWX", PPC_INSN_ECIWX, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_ecowx, "ECOWX", PPC_INSN_ECOWX, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_eieio, "EIEIO", PPC_INSN_EIEIO, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },
  { ppc_sem_mfmsr, "MFMSR", PPC_INSN_MFMSR, { 0, (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_USER } },
  { ppc_sem_mtmsr, "MTMSR", PPC_INSN_MTMSR, { 0, (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_USER } },
  { ppc_sem_mfspr, "MFSPR", PPC_INSN_MFSPR, { 0, (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_USER } },
  { ppc_sem_mtspr, "MTSPR", PPC_INSN_MTSPR, { 0, (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_USER } },
  { ppc_sem_mtsr, "MTSR", PPC_INSN_MTSR, { 0, (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_SUPERVISOR } },
  { ppc_sem_mfsr, "MFSR", PPC_INSN_MFSR, { 0, (1<<MACH_BASE), ARCH_LEVEL_OEA, INSN_LEVEL_SUPERVISOR } },
  { ppc_sem_mftb, "MFTB", PPC_INSN_MFTB, { 0, (1<<MACH_BASE), ARCH_LEVEL_VEA, INSN_LEVEL_USER } },

};

// Given a canonical virtual insn id, return the target specific one.

ppc_insn_type
ppc_idesc::lookup_virtual (virtual_insn_type vit)
{
  switch (vit)
    {
      case VIRTUAL_INSN_INVALID: return PPC_INSN_X_INVALID;
      case VIRTUAL_INSN_COND: return PPC_INSN_X_INVALID;
    }
  abort ();
}


// Declare extractor functions

static void
ppc_extract_sfmt_empty (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_add (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_addc (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_adde (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_addme (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_addic (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_addic_ (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_addi (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_neg (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mulhw (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mulli (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_cmpix (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_cmplix (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_cmp (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_cmpl (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_and (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_andi_ (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_xori (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_extsb (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_rlwimi (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_rlwnm (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_srawi (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lbz (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lbzu (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lbzux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lbzx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lha (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lhau (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lhaux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lhax (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lwz (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lwzu (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lwzux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lwzx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lhbrx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lwbrx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_lmw (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_stb (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_stbu (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_stbux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_stbx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_sth (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_sthu (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_sthux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_sthx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_stw (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_stwu (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_stwux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_stwx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_stmw (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_tw (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_twi (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_sc (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_rfi (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_b (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_bcctr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_bclr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_bc (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_crand (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mcrf (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mcrxr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mfcr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_dcba (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mfmsr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mtmsr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mfspr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mtspr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mtsr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mfsr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
static void
ppc_extract_sfmt_mftb (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);

// Fetch & decode instruction
void
ppc_scache::decode (ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn)
{
  /* Result of decoder.  */
  PPC_INSN_TYPE itype;

  {
    ppc_insn_word insn = base_insn;

    {
      unsigned int val = (((insn >> 26) & (63 << 0)));
      switch (val)
      {
      case 3 : itype = PPC_INSN_TWI; ppc_extract_sfmt_twi (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 7 : itype = PPC_INSN_MULLI; ppc_extract_sfmt_mulli (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 8 : itype = PPC_INSN_SUBFIC; ppc_extract_sfmt_addic (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 10 : itype = PPC_INSN_CMPLIX; ppc_extract_sfmt_cmplix (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 11 : itype = PPC_INSN_CMPIX; ppc_extract_sfmt_cmpix (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 12 : itype = PPC_INSN_ADDIC; ppc_extract_sfmt_addic (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 13 : itype = PPC_INSN_ADDIC_; ppc_extract_sfmt_addic_ (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 14 : itype = PPC_INSN_ADDI; ppc_extract_sfmt_addi (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 15 : itype = PPC_INSN_ADDIS; ppc_extract_sfmt_addi (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 16 : itype = PPC_INSN_BC; ppc_extract_sfmt_bc (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 17 : itype = PPC_INSN_SC; ppc_extract_sfmt_sc (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 18 : itype = PPC_INSN_B; ppc_extract_sfmt_b (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 19 :
        {
          unsigned int val = (((insn >> 4) & (31 << 1)) | ((insn >> 1) & (1 << 0)));
          switch (val)
          {
          case 0 : itype = PPC_INSN_MCRF; ppc_extract_sfmt_mcrf (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 2 :
            {
              unsigned int val = (((insn >> 10) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_BCLR; ppc_extract_sfmt_bclr (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_BCCTR; ppc_extract_sfmt_bcctr (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 5 : itype = PPC_INSN_CRNOR; ppc_extract_sfmt_crand (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 6 : itype = PPC_INSN_RFI; ppc_extract_sfmt_rfi (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 17 : itype = PPC_INSN_CRANDC; ppc_extract_sfmt_crand (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 18 : itype = PPC_INSN_ISYNC; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 25 : itype = PPC_INSN_CRXOR; ppc_extract_sfmt_crand (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 29 : itype = PPC_INSN_CRNAND; ppc_extract_sfmt_crand (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 33 : itype = PPC_INSN_CRAND; ppc_extract_sfmt_crand (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 37 : itype = PPC_INSN_CREQV; ppc_extract_sfmt_crand (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 53 : itype = PPC_INSN_CRORC; ppc_extract_sfmt_crand (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 57 : itype = PPC_INSN_CROR; ppc_extract_sfmt_crand (this, current_cpu, pc, base_insn, entire_insn); goto done;
          default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
          }
        }
      case 20 : itype = PPC_INSN_RLWIMI; ppc_extract_sfmt_rlwimi (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 21 : itype = PPC_INSN_RLWINM; ppc_extract_sfmt_rlwimi (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 23 : itype = PPC_INSN_RLWNM; ppc_extract_sfmt_rlwnm (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 24 : itype = PPC_INSN_ORI; ppc_extract_sfmt_xori (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 25 : itype = PPC_INSN_ORIS; ppc_extract_sfmt_xori (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 26 : itype = PPC_INSN_XORI; ppc_extract_sfmt_xori (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 27 : itype = PPC_INSN_XORIS; ppc_extract_sfmt_xori (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 28 : itype = PPC_INSN_ANDI_; ppc_extract_sfmt_andi_ (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 29 : itype = PPC_INSN_ANDIS_; ppc_extract_sfmt_andi_ (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 31 :
        {
          unsigned int val = (((insn >> 3) & (15 << 3)) | ((insn >> 2) & (3 << 1)) | ((insn >> 1) & (1 << 0)));
          switch (val)
          {
          case 0 :
            {
              unsigned int val = (((insn >> 10) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_CMP; ppc_extract_sfmt_cmp (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_MCRXR; ppc_extract_sfmt_mcrxr (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 1 : itype = PPC_INSN_MFCR; ppc_extract_sfmt_mfcr (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 2 :
            {
              unsigned int val = (((insn >> 8) & (1 << 2)) | ((insn >> 4) & (1 << 1)) | ((insn >> 2) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_TW; ppc_extract_sfmt_tw (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 2 : itype = PPC_INSN_LWARX; ppc_extract_sfmt_lwbrx (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 7 : itype = PPC_INSN_LWBRX; ppc_extract_sfmt_lwbrx (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 3 : itype = PPC_INSN_LWZX; ppc_extract_sfmt_lwzx (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 4 :
            {
              unsigned int val = (((insn >> 4) & (1 << 1)) | ((insn >> 2) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_SUBFC; ppc_extract_sfmt_addc (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_ADDC; ppc_extract_sfmt_addc (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 2 :
                {
                  unsigned int val = (((insn >> 10) & (1 << 0)));
                  switch (val)
                  {
                  case 0 : itype = PPC_INSN_SLW; ppc_extract_sfmt_and (this, current_cpu, pc, base_insn, entire_insn); goto done;
                  case 1 : itype = PPC_INSN_SRW; ppc_extract_sfmt_srawi (this, current_cpu, pc, base_insn, entire_insn); goto done;
                  default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
                  }
                }
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 5 : itype = PPC_INSN_MULHWU; ppc_extract_sfmt_mulhw (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 6 : itype = PPC_INSN_AND; ppc_extract_sfmt_and (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 8 : itype = PPC_INSN_CMPL; ppc_extract_sfmt_cmpl (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 10 :
            {
              unsigned int val = (((insn >> 10) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_DCBST; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_TLBSYNC; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 11 : itype = PPC_INSN_LWZUX; ppc_extract_sfmt_lwzux (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 12 : itype = PPC_INSN_SUBF; ppc_extract_sfmt_add (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 14 : itype = PPC_INSN_ANDC; ppc_extract_sfmt_and (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 17 :
            {
              unsigned int val = (((insn >> 10) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_MFMSR; ppc_extract_sfmt_mfmsr (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_MFSR; ppc_extract_sfmt_mfsr (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 18 :
            {
              unsigned int val = (((insn >> 10) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_DCBF; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_SYNC; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 19 : itype = PPC_INSN_LBZX; ppc_extract_sfmt_lbzx (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 21 : itype = PPC_INSN_MULHW; ppc_extract_sfmt_mulhw (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 27 : itype = PPC_INSN_LBZUX; ppc_extract_sfmt_lbzux (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 28 : itype = PPC_INSN_NEG; ppc_extract_sfmt_neg (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 30 : itype = PPC_INSN_NOR; ppc_extract_sfmt_and (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 32 : itype = PPC_INSN_MTMSR; ppc_extract_sfmt_mtmsr (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 35 : itype = PPC_INSN_STWX; ppc_extract_sfmt_stwx (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 36 :
            {
              unsigned int val = (((insn >> 2) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_SUBFE; ppc_extract_sfmt_adde (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_ADDE; ppc_extract_sfmt_adde (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 43 : itype = PPC_INSN_STWUX; ppc_extract_sfmt_stwux (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 48 : itype = PPC_INSN_MTSR; ppc_extract_sfmt_mtsr (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 51 : itype = PPC_INSN_STBX; ppc_extract_sfmt_stbx (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 52 :
            {
              unsigned int val = (((insn >> 2) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_SUBFZE; ppc_extract_sfmt_addme (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_ADDZE; ppc_extract_sfmt_addme (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 58 :
            {
              unsigned int val = (((insn >> 10) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_DCBTST; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_DCBA; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 59 : itype = PPC_INSN_STBUX; ppc_extract_sfmt_stbux (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 60 :
            {
              unsigned int val = (((insn >> 2) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_SUBFME; ppc_extract_sfmt_addme (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_ADDME; ppc_extract_sfmt_addme (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 61 : itype = PPC_INSN_MULLW; ppc_extract_sfmt_add (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 66 :
            {
              unsigned int val = (((insn >> 10) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_DCBT; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_LHBRX; ppc_extract_sfmt_lhbrx (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 67 : itype = PPC_INSN_LHZX; ppc_extract_sfmt_lhax (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 68 :
            {
              unsigned int val = (((insn >> 4) & (1 << 1)) | ((insn >> 2) & (1 << 0)));
              switch (val)
              {
              case 1 : itype = PPC_INSN_ADD; ppc_extract_sfmt_add (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 2 : itype = PPC_INSN_SRAW; ppc_extract_sfmt_and (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 70 : itype = PPC_INSN_EQV; ppc_extract_sfmt_and (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 72 : itype = PPC_INSN_TLBIE; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 74 : itype = PPC_INSN_ECIWX; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 75 : itype = PPC_INSN_LHZUX; ppc_extract_sfmt_lhaux (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 76 : itype = PPC_INSN_SRAWI; ppc_extract_sfmt_srawi (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 78 : itype = PPC_INSN_XOR; ppc_extract_sfmt_and (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 81 : itype = PPC_INSN_MFSPR; ppc_extract_sfmt_mfspr (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 82 : itype = PPC_INSN_EIEIO; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 83 : itype = PPC_INSN_LHAX; ppc_extract_sfmt_lhax (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 88 : itype = PPC_INSN_TLBIA; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 89 : itype = PPC_INSN_MFTB; ppc_extract_sfmt_mftb (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 91 : itype = PPC_INSN_LHAUX; ppc_extract_sfmt_lhaux (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 99 : itype = PPC_INSN_STHX; ppc_extract_sfmt_sthx (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 100 : itype = PPC_INSN_EXTSH; ppc_extract_sfmt_extsb (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 102 : itype = PPC_INSN_ORC; ppc_extract_sfmt_and (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 106 : itype = PPC_INSN_ECOWX; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 107 : itype = PPC_INSN_STHUX; ppc_extract_sfmt_sthux (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 108 : itype = PPC_INSN_EXTSB; ppc_extract_sfmt_extsb (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 110 : itype = PPC_INSN_OR; ppc_extract_sfmt_and (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 113 : itype = PPC_INSN_MTSPR; ppc_extract_sfmt_mtspr (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 114 :
            {
              unsigned int val = (((insn >> 10) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = PPC_INSN_DCBI; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
              case 1 : itype = PPC_INSN_ICBI; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
              default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
              }
            }
          case 117 : itype = PPC_INSN_DIVWU; ppc_extract_sfmt_add (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 118 : itype = PPC_INSN_NAND; ppc_extract_sfmt_and (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 122 : itype = PPC_INSN_DCBZ; ppc_extract_sfmt_dcba (this, current_cpu, pc, base_insn, entire_insn); goto done;
          case 125 : itype = PPC_INSN_DIVW; ppc_extract_sfmt_add (this, current_cpu, pc, base_insn, entire_insn); goto done;
          default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
          }
        }
      case 32 : itype = PPC_INSN_LWZ; ppc_extract_sfmt_lwz (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 33 : itype = PPC_INSN_LWZU; ppc_extract_sfmt_lwzu (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 34 : itype = PPC_INSN_LBZ; ppc_extract_sfmt_lbz (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 35 : itype = PPC_INSN_LBZU; ppc_extract_sfmt_lbzu (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 36 : itype = PPC_INSN_STW; ppc_extract_sfmt_stw (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 37 : itype = PPC_INSN_STWU; ppc_extract_sfmt_stwu (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 38 : itype = PPC_INSN_STB; ppc_extract_sfmt_stb (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 39 : itype = PPC_INSN_STBU; ppc_extract_sfmt_stbu (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 40 : itype = PPC_INSN_LHZ; ppc_extract_sfmt_lha (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 41 : itype = PPC_INSN_LHZU; ppc_extract_sfmt_lhau (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 42 : itype = PPC_INSN_LHA; ppc_extract_sfmt_lha (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 43 : itype = PPC_INSN_LHAU; ppc_extract_sfmt_lhau (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 44 : itype = PPC_INSN_STH; ppc_extract_sfmt_sth (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 45 : itype = PPC_INSN_STHU; ppc_extract_sfmt_sthu (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 46 : itype = PPC_INSN_LMW; ppc_extract_sfmt_lmw (this, current_cpu, pc, base_insn, entire_insn); goto done;
      case 47 : itype = PPC_INSN_STMW; ppc_extract_sfmt_stmw (this, current_cpu, pc, base_insn, entire_insn); goto done;
      default : itype = PPC_INSN_X_INVALID; ppc_extract_sfmt_empty (this, current_cpu, pc, base_insn, entire_insn);  goto done;
      }
    }

  }

  /* The instruction has been decoded and fields extracted.  */
  done:

  this->addr = pc;
  // FIXME: To be redone (to handle ISA variants).
  this->idesc = & ppc_idesc::idesc_table[itype];
  // ??? record semantic handler?
  assert(this->idesc->sem_index == itype);
}

void
ppc_extract_sfmt_empty (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.fmt_empty.f


  /* Record the fields for the semantic handler.  */
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_empty)\t"
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_add (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;
    UINT f_oe;
    UINT f_rc;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);
    f_oe = EXTRACT_MSB0_UINT (insn, 32, 21, 1);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_oe) = f_oe;
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rc) = f_rc;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_add)\t"
        << " f_oe:0x" << hex << f_oe << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_addc (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;
    UINT f_oe;
    UINT f_rc;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);
    f_oe = EXTRACT_MSB0_UINT (insn, 32, 21, 1);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_oe) = f_oe;
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rc) = f_rc;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_addc)\t"
        << " f_oe:0x" << hex << f_oe << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_adde (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;
    UINT f_oe;
    UINT f_rc;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);
    f_oe = EXTRACT_MSB0_UINT (insn, 32, 21, 1);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_oe) = f_oe;
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rc) = f_rc;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_adde)\t"
        << " f_oe:0x" << hex << f_oe << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_addme (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_oe;
    UINT f_rc;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_oe = EXTRACT_MSB0_UINT (insn, 32, 21, 1);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_oe) = f_oe;
  FLD (f_ra) = f_ra;
  FLD (f_rc) = f_rc;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_addme)\t"
        << " f_oe:0x" << hex << f_oe << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_addic (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mulli.f
    UINT f_rd;
    UINT f_ra;
    INT f_simm;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_simm = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_simm) = f_simm;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_addic)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_simm:0x" << hex << f_simm << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_addic_ (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mulli.f
    UINT f_rd;
    UINT f_ra;
    INT f_simm;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_simm = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rd) = f_rd;
  FLD (f_simm) = f_simm;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_addic_)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rd:0x" << hex << f_rd << dec
        << " f_simm:0x" << hex << f_simm << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_addi (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mulli.f
    UINT f_rd;
    UINT f_ra;
    INT f_simm;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_simm = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_simm) = f_simm;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_addi)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_simm:0x" << hex << f_simm << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_neg (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_oe;
    UINT f_rc;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_oe = EXTRACT_MSB0_UINT (insn, 32, 21, 1);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_oe) = f_oe;
  FLD (f_ra) = f_ra;
  FLD (f_rc) = f_rc;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_neg)\t"
        << " f_oe:0x" << hex << f_oe << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mulhw (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;
    UINT f_rc;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rc) = f_rc;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mulhw)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mulli (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mulli.f
    UINT f_rd;
    UINT f_ra;
    INT f_simm;
    UINT f_rc;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_simm = EXTRACT_MSB0_INT (insn, 32, 16, 16);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rc) = f_rc;
  FLD (f_rd) = f_rd;
  FLD (f_simm) = f_simm;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mulli)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rd:0x" << hex << f_rd << dec
        << " f_simm:0x" << hex << f_simm << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_cmpix (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_cmpix.f
    UINT f_crfd;
    UINT f_ra;
    INT f_simm;

    f_crfd = EXTRACT_MSB0_UINT (insn, 32, 6, 3);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_simm = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_simm) = f_simm;
  FLD (f_crfd) = f_crfd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_cmpix)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_simm:0x" << hex << f_simm << dec
        << " f_crfd:0x" << hex << f_crfd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_cmplix (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_cmplix.f
    UINT f_crfd;
    UINT f_ra;
    UINT f_uimm;

    f_crfd = EXTRACT_MSB0_UINT (insn, 32, 6, 3);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_uimm = EXTRACT_MSB0_UINT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_uimm) = f_uimm;
  FLD (f_crfd) = f_crfd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_cmplix)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_uimm:0x" << hex << f_uimm << dec
        << " f_crfd:0x" << hex << f_crfd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_cmp (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_cmp.f
    UINT f_crfd;
    UINT f_ra;
    UINT f_rb;

    f_crfd = EXTRACT_MSB0_UINT (insn, 32, 6, 3);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_crfd) = f_crfd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_cmp)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_crfd:0x" << hex << f_crfd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_cmpl (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_cmp.f
    UINT f_crfd;
    UINT f_ra;
    UINT f_rb;

    f_crfd = EXTRACT_MSB0_UINT (insn, 32, 6, 3);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_crfd) = f_crfd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_cmpl)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_crfd:0x" << hex << f_crfd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_and (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwnm.f
    UINT f_rs;
    UINT f_ra;
    UINT f_rb;
    UINT f_rc;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rc) = f_rc;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_and)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_andi_ (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_andi_.f
    UINT f_rs;
    UINT f_ra;
    UINT f_uimm;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_uimm = EXTRACT_MSB0_UINT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rs) = f_rs;
  FLD (f_uimm) = f_uimm;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_andi_)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rs:0x" << hex << f_rs << dec
        << " f_uimm:0x" << hex << f_uimm << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_xori (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_andi_.f
    UINT f_rs;
    UINT f_ra;
    UINT f_uimm;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_uimm = EXTRACT_MSB0_UINT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_rs) = f_rs;
  FLD (f_uimm) = f_uimm;
  FLD (f_ra) = f_ra;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_xori)\t"
        << " f_rs:0x" << hex << f_rs << dec
        << " f_uimm:0x" << hex << f_uimm << dec
        << " f_ra:0x" << hex << f_ra << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_extsb (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwnm.f
    UINT f_rs;
    UINT f_ra;
    UINT f_rc;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rc) = f_rc;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_extsb)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_rlwimi (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwimi.f
    UINT f_rs;
    UINT f_ra;
    UINT f_sh;
    UINT f_mb;
    UINT f_me;
    UINT f_rc;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_sh = EXTRACT_MSB0_UINT (insn, 32, 16, 5);
    f_mb = EXTRACT_MSB0_UINT (insn, 32, 21, 5);
    f_me = EXTRACT_MSB0_UINT (insn, 32, 26, 5);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_mb) = f_mb;
  FLD (f_me) = f_me;
  FLD (f_ra) = f_ra;
  FLD (f_rc) = f_rc;
  FLD (f_rs) = f_rs;
  FLD (f_sh) = f_sh;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_rlwimi)\t"
        << " f_mb:0x" << hex << f_mb << dec
        << " f_me:0x" << hex << f_me << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rs:0x" << hex << f_rs << dec
        << " f_sh:0x" << hex << f_sh << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_rlwnm (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwnm.f
    UINT f_rs;
    UINT f_ra;
    UINT f_rb;
    UINT f_mb;
    UINT f_me;
    UINT f_rc;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);
    f_mb = EXTRACT_MSB0_UINT (insn, 32, 21, 5);
    f_me = EXTRACT_MSB0_UINT (insn, 32, 26, 5);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_mb) = f_mb;
  FLD (f_me) = f_me;
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rc) = f_rc;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_rlwnm)\t"
        << " f_mb:0x" << hex << f_mb << dec
        << " f_me:0x" << hex << f_me << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_srawi (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwimi.f
    UINT f_rs;
    UINT f_ra;
    UINT f_sh;
    UINT f_rc;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_sh = EXTRACT_MSB0_UINT (insn, 32, 16, 5);
    f_rc = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rc) = f_rc;
  FLD (f_rs) = f_rs;
  FLD (f_sh) = f_sh;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_srawi)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rc:0x" << hex << f_rc << dec
        << " f_rs:0x" << hex << f_rs << dec
        << " f_sh:0x" << hex << f_sh << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lbz (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lbz.f
    UINT f_rd;
    UINT f_ra;
    INT f_d;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lbz)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lbzu (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lbz.f
    UINT f_rd;
    UINT f_ra;
    INT f_d;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lbzu)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lbzux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lbzux)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lbzx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lbzx)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lha (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lbz.f
    UINT f_rd;
    UINT f_ra;
    INT f_d;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lha)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lhau (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lbz.f
    UINT f_rd;
    UINT f_ra;
    INT f_d;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lhau)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lhaux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lhaux)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lhax (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lhax)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lwz (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lbz.f
    UINT f_rd;
    UINT f_ra;
    INT f_d;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lwz)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lwzu (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lbz.f
    UINT f_rd;
    UINT f_ra;
    INT f_d;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lwzu)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lwzux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lwzux)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lwzx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lwzx)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lhbrx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lhbrx)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lwbrx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_add.f
    UINT f_rd;
    UINT f_ra;
    UINT f_rb;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lwbrx)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_lmw (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lbz.f
    UINT f_rd;
    UINT f_ra;
    INT f_d;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_rd) = f_rd;
  FLD (f_ra) = f_ra;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_lmw)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_rd:0x" << hex << f_rd << dec
        << " f_ra:0x" << hex << f_ra << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_stb (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_stb.f
    UINT f_rs;
    UINT f_ra;
    INT f_d;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_stb)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_stbu (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_stb.f
    UINT f_rs;
    UINT f_ra;
    INT f_d;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_stbu)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_stbux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwnm.f
    UINT f_rs;
    UINT f_ra;
    UINT f_rb;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_stbux)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_stbx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwnm.f
    UINT f_rs;
    UINT f_ra;
    UINT f_rb;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_stbx)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_sth (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_stb.f
    UINT f_rs;
    UINT f_ra;
    INT f_d;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_sth)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_sthu (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_stb.f
    UINT f_rs;
    UINT f_ra;
    INT f_d;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_sthu)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_sthux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwnm.f
    UINT f_rs;
    UINT f_ra;
    UINT f_rb;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_sthux)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_sthx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwnm.f
    UINT f_rs;
    UINT f_ra;
    UINT f_rb;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_sthx)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_stw (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_stb.f
    UINT f_rs;
    UINT f_ra;
    INT f_d;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_stw)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_stwu (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_stb.f
    UINT f_rs;
    UINT f_ra;
    INT f_d;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_ra) = f_ra;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_stwu)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_stwux (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwnm.f
    UINT f_rs;
    UINT f_ra;
    UINT f_rb;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_stwux)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_stwx (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_rlwnm.f
    UINT f_rs;
    UINT f_ra;
    UINT f_rb;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_rs) = f_rs;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_stwx)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_rs:0x" << hex << f_rs << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_stmw (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_stb.f
    UINT f_rs;
    UINT f_ra;
    INT f_d;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_d = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_d) = f_d;
  FLD (f_rs) = f_rs;
  FLD (f_ra) = f_ra;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_stmw)\t"
        << " f_d:0x" << hex << f_d << dec
        << " f_rs:0x" << hex << f_rs << dec
        << " f_ra:0x" << hex << f_ra << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_tw (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_tw.f
    UINT f_to;
    UINT f_ra;
    UINT f_rb;

    f_to = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_rb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_rb) = f_rb;
  FLD (f_to) = f_to;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_tw)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_rb:0x" << hex << f_rb << dec
        << " f_to:0x" << hex << f_to << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_twi (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_twi.f
    UINT f_to;
    UINT f_ra;
    INT f_simm;

    f_to = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_ra = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_simm = EXTRACT_MSB0_INT (insn, 32, 16, 16);

  /* Record the fields for the semantic handler.  */
  FLD (f_ra) = f_ra;
  FLD (f_simm) = f_simm;
  FLD (f_to) = f_to;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_twi)\t"
        << " f_ra:0x" << hex << f_ra << dec
        << " f_simm:0x" << hex << f_simm << dec
        << " f_to:0x" << hex << f_to << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_sc (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.fmt_empty.f


  /* Record the fields for the semantic handler.  */
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_sc)\t"
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_rfi (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.fmt_empty.f


  /* Record the fields for the semantic handler.  */
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_rfi)\t"
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_b (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_b.f
    INT f_li;
    UINT f_aa;
    UINT f_lk;

    f_li = EXTRACT_MSB0_INT (insn, 32, 6, 24);
    f_aa = EXTRACT_MSB0_UINT (insn, 32, 30, 1);
    f_lk = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_aa) = f_aa;
  FLD (f_lk) = f_lk;
  FLD (i_li) = f_li;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_b)\t"
        << " f_aa:0x" << hex << f_aa << dec
        << " f_lk:0x" << hex << f_lk << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_bcctr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_bc.f
    UINT f_bo;
    UINT f_bi;
    UINT f_lk;

    f_bo = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_bi = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_lk = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_bi) = f_bi;
  FLD (f_bo) = f_bo;
  FLD (f_lk) = f_lk;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_bcctr)\t"
        << " f_bi:0x" << hex << f_bi << dec
        << " f_bo:0x" << hex << f_bo << dec
        << " f_lk:0x" << hex << f_lk << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_bclr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_bc.f
    UINT f_bo;
    UINT f_bi;
    UINT f_lk;

    f_bo = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_bi = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_lk = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_bi) = f_bi;
  FLD (f_bo) = f_bo;
  FLD (f_lk) = f_lk;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_bclr)\t"
        << " f_bi:0x" << hex << f_bi << dec
        << " f_bo:0x" << hex << f_bo << dec
        << " f_lk:0x" << hex << f_lk << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_bc (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_bc.f
    UINT f_bo;
    UINT f_bi;
    INT f_bd;
    UINT f_aa;
    UINT f_lk;

    f_bo = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_bi = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_bd = EXTRACT_MSB0_INT (insn, 32, 16, 14);
    f_aa = EXTRACT_MSB0_UINT (insn, 32, 30, 1);
    f_lk = EXTRACT_MSB0_UINT (insn, 32, 31, 1);

  /* Record the fields for the semantic handler.  */
  FLD (f_bi) = f_bi;
  FLD (f_bo) = f_bo;
  FLD (f_aa) = f_aa;
  FLD (f_lk) = f_lk;
  FLD (i_bd) = f_bd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_bc)\t"
        << " f_bi:0x" << hex << f_bi << dec
        << " f_bo:0x" << hex << f_bo << dec
        << " f_aa:0x" << hex << f_aa << dec
        << " f_lk:0x" << hex << f_lk << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_crand (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_crand.f
    UINT f_crbd;
    UINT f_crba;
    UINT f_crbb;

    f_crbd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_crba = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_crbb = EXTRACT_MSB0_UINT (insn, 32, 16, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_crba) = f_crba;
  FLD (f_crbb) = f_crbb;
  FLD (f_crbd) = f_crbd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_crand)\t"
        << " f_crba:0x" << hex << f_crba << dec
        << " f_crbb:0x" << hex << f_crbb << dec
        << " f_crbd:0x" << hex << f_crbd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mcrf (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mcrf.f
    UINT f_crfd;
    UINT f_crfs;

    f_crfd = EXTRACT_MSB0_UINT (insn, 32, 6, 3);
    f_crfs = EXTRACT_MSB0_UINT (insn, 32, 6, 3);

  /* Record the fields for the semantic handler.  */
  FLD (f_crfs) = f_crfs;
  FLD (f_crfd) = f_crfd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mcrf)\t"
        << " f_crfs:0x" << hex << f_crfs << dec
        << " f_crfd:0x" << hex << f_crfd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mcrxr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mcrf.f
    UINT f_crfd;

    f_crfd = EXTRACT_MSB0_UINT (insn, 32, 6, 3);

  /* Record the fields for the semantic handler.  */
  FLD (f_crfd) = f_crfd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mcrxr)\t"
        << " f_crfd:0x" << hex << f_crfd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mfcr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mftb.f
    UINT f_rd;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mfcr)\t"
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_dcba (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.fmt_empty.f


  /* Record the fields for the semantic handler.  */
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_dcba)\t"
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mfmsr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mftb.f
    UINT f_rd;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mfmsr)\t"
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mtmsr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mftb.f
    UINT f_rd;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mtmsr)\t"
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mfspr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mfspr.f
    UINT f_rd;
    UINT f_spr_l;
    UINT f_spr_h;
    UINT f_spr;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_spr_l = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_spr_h = EXTRACT_MSB0_UINT (insn, 32, 16, 5);
{
  f_spr = ((((f_spr_h) << (5))) | (f_spr_l));
}

  /* Record the fields for the semantic handler.  */
  FLD (f_spr) = f_spr;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mfspr)\t"
        << " f_spr:0x" << hex << f_spr << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mtspr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mtspr.f
    UINT f_rs;
    UINT f_spr_l;
    UINT f_spr_h;
    UINT f_spr;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_spr_l = EXTRACT_MSB0_UINT (insn, 32, 11, 5);
    f_spr_h = EXTRACT_MSB0_UINT (insn, 32, 16, 5);
{
  f_spr = ((((f_spr_h) << (5))) | (f_spr_l));
}

  /* Record the fields for the semantic handler.  */
  FLD (f_rs) = f_rs;
  FLD (f_spr) = f_spr;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mtspr)\t"
        << " f_rs:0x" << hex << f_rs << dec
        << " f_spr:0x" << hex << f_spr << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mtsr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mtsr.f
    UINT f_rs;
    UINT f_sr;

    f_rs = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_sr = EXTRACT_MSB0_UINT (insn, 32, 12, 4);

  /* Record the fields for the semantic handler.  */
  FLD (f_rs) = f_rs;
  FLD (f_sr) = f_sr;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mtsr)\t"
        << " f_rs:0x" << hex << f_rs << dec
        << " f_sr:0x" << hex << f_sr << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mfsr (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mfsr.f
    UINT f_rd;
    UINT f_sr;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_sr = EXTRACT_MSB0_UINT (insn, 32, 12, 4);

  /* Record the fields for the semantic handler.  */
  FLD (f_sr) = f_sr;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mfsr)\t"
        << " f_sr:0x" << hex << f_sr << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

void
ppc_extract_sfmt_mftb (ppc_scache* abuf, ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn){
    ppc_insn_word insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_mftb.f
    UINT f_rd;
    UINT f_tbr;

    f_rd = EXTRACT_MSB0_UINT (insn, 32, 6, 5);
    f_tbr = EXTRACT_MSB0_UINT (insn, 32, 11, 10);

  /* Record the fields for the semantic handler.  */
  FLD (f_tbr) = f_tbr;
  FLD (f_rd) = f_rd;
  if (UNLIKELY(current_cpu->trace_extract_p))
    {
      current_cpu->trace_stream 
        << "0x" << hex << pc << dec << " (sfmt_mftb)\t"
        << " f_tbr:0x" << hex << f_tbr << dec
        << " f_rd:0x" << hex << f_rd << dec
        << endl;
    }

#undef FLD
}

