/* Simulator instruction operand writer for powerpc.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 2000, 2001 Red Hat, Inc.

This file is part of the Red Hat simulators.


*/


#include "ppcbf.h"
using namespace ppcbf;


sem_status
ppc_write_sfmt_empty (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.fmt_empty.f
#define OPRND(f) par_exec->operands.sfmt_empty.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto


  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_add (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_add.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 6))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);
  if (written & (1ULL << 8))
    {
      current_cpu->hardware.h_xer_ov = OPRND (xer_ov);
    }
  if (written & (1ULL << 9))
    {
      current_cpu->hardware.h_xer_so = OPRND (xer_so);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_addc (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_addc.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 6))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);
  current_cpu->hardware.h_xer_ca = OPRND (xer_ca);
  if (written & (1ULL << 9))
    {
      current_cpu->hardware.h_xer_ov = OPRND (xer_ov);
    }
  if (written & (1ULL << 10))
    {
      current_cpu->hardware.h_xer_so = OPRND (xer_so);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_adde (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_adde.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 7))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);
  current_cpu->hardware.h_xer_ca = OPRND (xer_ca);
  if (written & (1ULL << 10))
    {
      current_cpu->hardware.h_xer_ov = OPRND (xer_ov);
    }
  if (written & (1ULL << 11))
    {
      current_cpu->hardware.h_xer_so = OPRND (xer_so);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_addme (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_addme.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 6))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);
  current_cpu->hardware.h_xer_ca = OPRND (xer_ca);
  if (written & (1ULL << 9))
    {
      current_cpu->hardware.h_xer_ov = OPRND (xer_ov);
    }
  if (written & (1ULL << 10))
    {
      current_cpu->hardware.h_xer_so = OPRND (xer_so);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_addic (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mulli.f
#define OPRND(f) par_exec->operands.sfmt_addic.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);
  current_cpu->hardware.h_xer_ca = OPRND (xer_ca);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_addic_ (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mulli.f
#define OPRND(f) par_exec->operands.sfmt_addic_.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);
  current_cpu->hardware.h_xer_ca = OPRND (xer_ca);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_addi (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mulli.f
#define OPRND(f) par_exec->operands.sfmt_addi.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_neg (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_neg.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 5))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);
  if (written & (1ULL << 7))
    {
      current_cpu->hardware.h_xer_ov = OPRND (xer_ov);
    }
  if (written & (1ULL << 8))
    {
      current_cpu->hardware.h_xer_so = OPRND (xer_so);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mulhw (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_mulhw.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 4))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mulli (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mulli.f
#define OPRND(f) par_exec->operands.sfmt_mulli.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 4))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_cmpix (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_cmpix.f
#define OPRND(f) par_exec->operands.sfmt_cmpix.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->h_cr_s_set (FLD (f_crfd), OPRND (crfd));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_cmplix (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_cmplix.f
#define OPRND(f) par_exec->operands.sfmt_cmplix.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->h_cr_s_set (FLD (f_crfd), OPRND (crfd));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_cmp (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_cmp.f
#define OPRND(f) par_exec->operands.sfmt_cmp.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->h_cr_s_set (FLD (f_crfd), OPRND (crfd));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_cmpl (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_cmp.f
#define OPRND(f) par_exec->operands.sfmt_cmpl.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->h_cr_s_set (FLD (f_crfd), OPRND (crfd));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_and (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwnm.f
#define OPRND(f) par_exec->operands.sfmt_and.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 4))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_andi_ (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_andi_.f
#define OPRND(f) par_exec->operands.sfmt_andi_.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_xori (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_andi_.f
#define OPRND(f) par_exec->operands.sfmt_xori.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_extsb (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwnm.f
#define OPRND(f) par_exec->operands.sfmt_extsb.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 3))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_rlwimi (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwimi.f
#define OPRND(f) par_exec->operands.sfmt_rlwimi.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 6))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_rlwnm (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwnm.f
#define OPRND(f) par_exec->operands.sfmt_rlwnm.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 6))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_srawi (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwimi.f
#define OPRND(f) par_exec->operands.sfmt_srawi.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 4))
    {
      current_cpu->h_cr_s_set (((UINT) 0), OPRND (h_cr_s_QI_0));
    }
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lbz (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_lbz.f
#define OPRND(f) par_exec->operands.sfmt_lbz.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lbzu (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_lbz.f
#define OPRND(f) par_exec->operands.sfmt_lbzu.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lbzux (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_lbzux.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lbzx (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_lbzx.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lha (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_lbz.f
#define OPRND(f) par_exec->operands.sfmt_lha.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lhau (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_lbz.f
#define OPRND(f) par_exec->operands.sfmt_lhau.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lhaux (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_lhaux.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lhax (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_lhax.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lwz (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_lbz.f
#define OPRND(f) par_exec->operands.sfmt_lwz.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lwzu (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_lbz.f
#define OPRND(f) par_exec->operands.sfmt_lwzu.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lwzux (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_lwzux.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);
  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lwzx (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_lwzx.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lhbrx (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_lhbrx.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lwbrx (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_add.f
#define OPRND(f) par_exec->operands.sfmt_lwbrx.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_lmw (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_lbz.f
#define OPRND(f) par_exec->operands.sfmt_lmw.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 5))
    {
      current_cpu->hardware.h_gpr[OPRND (h_gpr_SI_n_idx)] = OPRND (h_gpr_SI_n);
    }
  if (written & (1ULL << 6))
    {
      current_cpu->branch (OPRND (pc), npc, status);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_stb (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_stb.f
#define OPRND(f) par_exec->operands.sfmt_stb.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMQI (pc, OPRND (h_memory_QI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_d_idx), OPRND (h_memory_QI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_d));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_stbu (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_stb.f
#define OPRND(f) par_exec->operands.sfmt_stbu.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMQI (pc, OPRND (h_memory_QI_add__DFLT_ra_d_idx), OPRND (h_memory_QI_add__DFLT_ra_d));
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_stbux (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwnm.f
#define OPRND(f) par_exec->operands.sfmt_stbux.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMQI (pc, OPRND (h_memory_QI_add__DFLT_ra_rb_idx), OPRND (h_memory_QI_add__DFLT_ra_rb));
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_stbx (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwnm.f
#define OPRND(f) par_exec->operands.sfmt_stbx.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMQI (pc, OPRND (h_memory_QI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_rb_idx), OPRND (h_memory_QI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_rb));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_sth (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_stb.f
#define OPRND(f) par_exec->operands.sfmt_sth.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMHI (pc, OPRND (h_memory_HI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_d_idx), OPRND (h_memory_HI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_d));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_sthu (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_stb.f
#define OPRND(f) par_exec->operands.sfmt_sthu.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMHI (pc, OPRND (h_memory_HI_add__DFLT_ra_d_idx), OPRND (h_memory_HI_add__DFLT_ra_d));
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_sthux (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwnm.f
#define OPRND(f) par_exec->operands.sfmt_sthux.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMHI (pc, OPRND (h_memory_HI_add__DFLT_ra_rb_idx), OPRND (h_memory_HI_add__DFLT_ra_rb));
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_sthx (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwnm.f
#define OPRND(f) par_exec->operands.sfmt_sthx.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMHI (pc, OPRND (h_memory_HI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_rb_idx), OPRND (h_memory_HI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_rb));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_stw (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_stb.f
#define OPRND(f) par_exec->operands.sfmt_stw.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMSI (pc, OPRND (h_memory_SI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_d_idx), OPRND (h_memory_SI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_d));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_stwu (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_stb.f
#define OPRND(f) par_exec->operands.sfmt_stwu.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMSI (pc, OPRND (h_memory_SI_add__DFLT_ra_d_idx), OPRND (h_memory_SI_add__DFLT_ra_d));
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_stwux (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwnm.f
#define OPRND(f) par_exec->operands.sfmt_stwux.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMSI (pc, OPRND (h_memory_SI_add__DFLT_ra_rb_idx), OPRND (h_memory_SI_add__DFLT_ra_rb));
  current_cpu->hardware.h_gpr[FLD (f_ra)] = OPRND (ra);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_stwx (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_rlwnm.f
#define OPRND(f) par_exec->operands.sfmt_stwx.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->SETMEMSI (pc, OPRND (h_memory_SI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_rb_idx), OPRND (h_memory_SI_add__DFLT_c_call__WI_ppcbf_get_reg_or_zero_index_of__DFLT_ra_rb));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_stmw (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_stb.f
#define OPRND(f) par_exec->operands.sfmt_stmw.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 5))
    {
      current_cpu->SETMEMSI (pc, OPRND (h_memory_SI_ea_idx), OPRND (h_memory_SI_ea));
    }
  if (written & (1ULL << 6))
    {
      current_cpu->branch (OPRND (pc), npc, status);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_tw (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_tw.f
#define OPRND(f) par_exec->operands.sfmt_tw.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 4))
    {
      current_cpu->branch (OPRND (pc), npc, status);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_twi (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_twi.f
#define OPRND(f) par_exec->operands.sfmt_twi.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 4))
    {
      current_cpu->branch (OPRND (pc), npc, status);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_sc (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.fmt_empty.f
#define OPRND(f) par_exec->operands.sfmt_sc.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->branch (OPRND (pc), npc, status);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_rfi (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.fmt_empty.f
#define OPRND(f) par_exec->operands.sfmt_rfi.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->branch (OPRND (pc), npc, status);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_b (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_b.f
#define OPRND(f) par_exec->operands.sfmt_b.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 4))
    {
      current_cpu->hardware.h_lr = OPRND (lr);
    }
  current_cpu->branch (OPRND (pc), npc, status);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_bcctr (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_bc.f
#define OPRND(f) par_exec->operands.sfmt_bcctr.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 5))
    {
      current_cpu->hardware.h_lr = OPRND (lr);
    }
  if (written & (1ULL << 6))
    {
      current_cpu->branch (OPRND (pc), npc, status);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_bclr (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_bc.f
#define OPRND(f) par_exec->operands.sfmt_bclr.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 6))
    {
      current_cpu->hardware.h_ctr = OPRND (ctr);
    }
  if (written & (1ULL << 7))
    {
      current_cpu->hardware.h_lr = OPRND (lr);
    }
  if (written & (1ULL << 8))
    {
      current_cpu->branch (OPRND (pc), npc, status);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_bc (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_bc.f
#define OPRND(f) par_exec->operands.sfmt_bc.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 7))
    {
      current_cpu->hardware.h_ctr = OPRND (ctr);
    }
  if (written & (1ULL << 8))
    {
      current_cpu->hardware.h_lr = OPRND (lr);
    }
  if (written & (1ULL << 9))
    {
      current_cpu->branch (OPRND (pc), npc, status);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_crand (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_crand.f
#define OPRND(f) par_exec->operands.sfmt_crand.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  if (written & (1ULL << 4))
    {
      current_cpu->hardware.h_cr = OPRND (h_cr_SI);
    }

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mcrf (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mcrf.f
#define OPRND(f) par_exec->operands.sfmt_mcrf.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->h_cr_s_set (FLD (f_crfd), OPRND (crfd));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mcrxr (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mcrf.f
#define OPRND(f) par_exec->operands.sfmt_mcrxr.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->h_cr_s_set (FLD (f_crfd), OPRND (crfd));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mfcr (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mftb.f
#define OPRND(f) par_exec->operands.sfmt_mfcr.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_dcba (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.fmt_empty.f
#define OPRND(f) par_exec->operands.sfmt_dcba.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto


  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mfmsr (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mftb.f
#define OPRND(f) par_exec->operands.sfmt_mfmsr.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mtmsr (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mftb.f
#define OPRND(f) par_exec->operands.sfmt_mtmsr.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_msr = OPRND (h_msr_SI);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mfspr (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mfspr.f
#define OPRND(f) par_exec->operands.sfmt_mfspr.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mtspr (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mtspr.f
#define OPRND(f) par_exec->operands.sfmt_mtspr.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->h_spr_set (FLD (f_spr), OPRND (spr));

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mtsr (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mtsr.f
#define OPRND(f) par_exec->operands.sfmt_mtsr.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_sr[FLD (f_sr)] = OPRND (sr);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mfsr (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mfsr.f
#define OPRND(f) par_exec->operands.sfmt_mfsr.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}


sem_status
ppc_write_sfmt_mftb (ppcbf_cpu* current_cpu, ppc_scache* sem, ppc_parexec* par_exec)
{
#define FLD(f) abuf->fields.sfmt_mftb.f
#define OPRND(f) par_exec->operands.sfmt_mftb.f
  ppc_scache* abuf = sem;
  unsigned long long written = abuf->written;
  PCADDR pc = abuf->addr;
  PCADDR npc = 0; // dummy value for branches
  sem_status status = SEM_STATUS_NORMAL; // ditto

  current_cpu->hardware.h_gpr[FLD (f_rd)] = OPRND (rd);

  return status;
#undef OPRND
#undef FLD
}

